<template>
    <div class="menus">
        <!-- <el-row :gutter="20"> -->
        <!-- <el-col :span="20"> -->
        <div class="menu-tree" style="width: 700px">
            <el-tree
                :data="menus"
                :render-content="renderContent"
                :highlight-current="true"
                :expand-on-click-node="true"
                node-key="id"
                v-loading="loading"
                accordion
                @node-click="nodeClick"
                :default-expanded-keys="expandKeys"
                :default-checked-keys="expandKeys"
            >
            </el-tree>
            <el-button type="text" @click="addRootMenu" style="margin-left: 24px;">添加 </el-button>
        </div>
        <!-- </el-col> -->
        <!-- <transition name="el-fade-in">
                <el-col :span="12" v-if="dialogVisible">
                    <div class="menu-tree">
                        <div style="font-weight:bold;padding:10px 0">{{ menu.id ? '编辑' : '新增' }}</div>
                        <el-form :model="menu" ref="form" label-position="top">
                            <el-form-item
                                label="名称"
                                prop="name"
                                :rules="[{ required: true, message: '请填写名称', trigger: 'blur' }]"
                            >
                                <el-input v-model="menu.name"></el-input>
                            </el-form-item>
                        </el-form>
                        <div slot="footer">
                            <el-button @click="dialogVisible = false">取消 </el-button>
                            <el-button type="primary" @click="addMenu" :loading="loading">保存 </el-button>
                        </div>
                    </div>
                </el-col>
            </transition> -->
        <!-- </el-row> -->

        <el-dialog :visible.sync="dialogVisible" width="500px">
            <el-form :model="menu" ref="form" label-position="top">
                <el-form-item
                    label="名称"
                    prop="name"
                    :rules="[{ required: true, message: '请填写名称', trigger: 'blur' }]"
                >
                    <el-input v-model="menu.name"></el-input>
                </el-form-item>
                <!-- <el-form-item label="代码" prop="code">
                                <el-input v-model="menu.code"></el-input>
                            </el-form-item> -->
            </el-form>
            <div slot="footer">
                <el-button @click="dialogVisible = false">取消 </el-button>
                <el-button type="primary" @click="addMenu" :loading="loading">保存 </el-button>
            </div>
        </el-dialog>
    </div>
</template>
<script>
export default {
    created() {
        this.getData();
    },
    data() {
        return {
            dialogVisible: false,
            curr: null,
            loading: false,
            menus: [],
            menu: {
                name: ''
            },
            parent: null,
            currentRef: null,
            edit: false,
            expandKeys: [],
            authorities: []
        };
    },
    methods: {
        addRootMenu() {
            this.menu = {
                name: ''
                // authorities: [{ name: 'ROLE_ADMIN' }]
            };
            this.parent = null;
            this.icon = 'bars';
            this.dialogVisible = true;
            setTimeout(() => {
                this.showIcon('bars');
            }, 100);
        },
        showAddDialog(node, data) {
            this.edit = false;
            this.parent = node.data;
            this.menu = {
                parent: node.data.id,
                flag: node.data.flag,
                name: ''
                // authorities: [{ name: 'ROLE_ADMIN' }]
            };
            this.dialogVisible = true;
        },
        showEditDialog(node, data) {
            this.edit = true;
            this.currentRef = node.data;
            this.menu = {
                ...data
            };
            this.dialogVisible = true;
        },
        addMenu() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.loading = true;
                    let menu = { ...this.menu };
                    delete menu.children;
                    this.$http
                        .post('/setting/save', menu, { body: 'json' })
                        .then(res => {
                            this.loading = false;
                            this.$message.success('添加成功');
                            this.dialogVisible = false;
                            this.getData();
                        })
                        .catch(e => {
                            console.log(e);
                            this.loading = false;
                            this.$message.error(e.error);
                        });
                }
            });
        },
        remove(node, data) {
            // console.log(node);
            this.$confirm('确定删除菜单？', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'error'
            })
                .then(() => {
                    return this.$http.post(
                        '/setting/save',
                        {
                            ...data,
                            del: true,
                            children: null
                        },
                        { body: 'json' }
                    );
                })
                .then(res => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    this.loading = false;
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        },
        moveUp(node, data) {
            if (node.previousSibling) {
                this.loading = true;
                let sort0 = node.previousSibling.data.sort,
                    sort1 = node.data.sort;
                Promise.all([
                    this.$http.post(
                        '/setting/save',
                        {
                            ...node.data,
                            children: null,
                            sort: sort0
                        },
                        { body: 'json' }
                    ),
                    this.$http.post(
                        '/setting/save',
                        {
                            ...node.previousSibling.data,
                            children: null,
                            sort: sort1
                        },
                        { body: 'json' }
                    )
                ])
                    .then(_ => {
                        this.loading = false;
                        this.getData();
                    })
                    .catch(e => {
                        console.log(e);
                        this.loading = false;
                        this.$message.error(e.error);
                    });
            }
        },
        moveDown(node, data) {
            // console.log(node);
            if (node.nextSibling) {
                this.loading = true;
                let sort0 = node.data.sort,
                    sort1 = node.nextSibling.data.sort;
                // console.log(sort0);
                // console.log(sort1);
                Promise.all([
                    this.$http.post(
                        '/setting/save',
                        {
                            ...node.data,
                            children: null,
                            sort: sort1
                        },
                        { body: 'json' }
                    ),
                    this.$http.post(
                        '/setting/save',
                        {
                            ...node.nextSibling.data,
                            children: null,
                            sort: sort0
                        },
                        { body: 'json' }
                    )
                ])
                    .then(_ => {
                        this.loading = false;
                        this.getData();
                    })
                    .catch(e => {
                        console.log(e);
                        this.loading = false;
                        this.$message.error(e.error);
                    });
            }
        },
        getData() {
            this.$http
                .post('/setting/allList')
                .then(res => {
                    this.menus = res;
                    console.log(this.menus);
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        },
        renderContent(h, { node, data, store }) {
            return (
                <span
                    class={
                        this.menu.id == data.id || (this.menu.parent == data.id && !this.menu.id)
                            ? 'custom-tree-node selected'
                            : 'custom-tree-node'
                    }
                >
                    <span>{data.name}</span>
                    <span class="url">{data.path}</span>
                    <span class="opt">
                        <el-button
                            type="text"
                            on-click={e => {
                                this.moveUp(node, data), e.stopPropagation();
                            }}
                            class="up"
                            icon="el-icon-top"
                        >
                            上移
                        </el-button>
                        <el-button
                            type="text"
                            on-click={e => {
                                this.moveDown(node, data), e.stopPropagation();
                            }}
                            icon="el-icon-bottom"
                        >
                            下移
                        </el-button>
                        <el-button
                            type="text"
                            on-click={e => {
                                this.showEditDialog(node, data), e.stopPropagation();
                            }}
                            icon="el-icon-edit"
                        >
                            编辑
                        </el-button>
                        <el-button
                            type="text"
                            on-click={e => {
                                this.showAddDialog(node, data), e.stopPropagation();
                            }}
                            icon="el-icon-plus"
                        >
                            添加
                        </el-button>
                        <el-button
                            type="text"
                            on-click={e => {
                                this.remove(node, data), e.stopPropagation();
                            }}
                            icon="el-icon-delete"
                        >
                            删除
                        </el-button>
                    </span>
                </span>
            );
        },
        showIcon(val) {
            if (!this.$refs.iconContainer) return;
            if (FontAwesome.icon({ prefix: 'fas', iconName: val })) {
                this.$refs.iconContainer.innerHTML = '';
                let i = document.createElement('i');
                i.className = 'fas fa-' + val;
                this.$refs.iconContainer.append(i);
                FontAwesome.dom.i2svg();
                this.menu.icon = 'fas fa-' + val;
            } else if (FontAwesome.icon({ prefix: 'fab', iconName: val })) {
                this.$refs.iconContainer.innerHTML = '';
                let i = document.createElement('i');
                i.className = 'fab fa-' + val;
                this.$refs.iconContainer.append(i);
                FontAwesome.dom.i2svg();
                this.menu.icon = 'fab fa-' + val;
            } else {
                this.$refs.iconContainer.innerHTML = '';
                let i = document.createElement('i');
                i.className = 'fab fa-' + val;
                this.$refs.iconContainer.append(i);
                FontAwesome.dom.i2svg();
                this.menu.icon = '';
            }
        },
        nodeClick(data, node, el) {
            if (this.expandKeys[0] != data.id) {
                this.expandKeys = [data.id];
            }
        }
    },
    watch: {
        icon(val) {
            this.showIcon(val);
        },
        category() {
            this.getData();
        }
    }
};
</script>
<style lang="less" scoped>
.menus {
    padding: 20px;
}
.menu-tree {
    border-radius: 4px;
    background: white;
    margin-top: 20px;
    padding: 10px;
}
/deep/ .custom-tree-node {
    flex: 1;
    display: flex;
    align-items: center;
    justify-content: space-between;
    font-size: 14px;
    padding-right: 8px;
    line-height: 40px;
    height: 40px;
    .url {
        flex-grow: 1;
        text-align: right;
        margin-right: 20px;
        color: #999;
    }
    .opt {
        opacity: 0;
    }
    &.selected {
        border: 2px solid @prim;
        border-radius: 4px;
        padding: 0 10px;
        box-sizing: border-box;
        .opt {
            opacity: 1;
        }
    }
    &:hover {
        .opt {
            opacity: 1;
        }
    }
}
/deep/ .menu-tree {
    .el-tree-node__content {
        height: 40px;
        line-height: 40px;
    }
}

/deep/ .available-icons {
    color: @prim;
    text-decoration: none;
    &:hover {
        color: @prim;
        text-decoration: none;
    }
}
</style>
